#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
/*
 * $Id: Commit_unit_end_cycle.cpp 88 2008-12-10 18:31:39Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h"

namespace morpheo {
namespace behavioural {
namespace core {
namespace multi_ooo_engine {
namespace ooo_engine {
namespace commit_unit {


#undef  FUNCTION
#define FUNCTION "Commit_unit::end_cycle"
void Commit_unit::end_cycle ()
  {
    log_begin(Commit_unit,FUNCTION);

#ifdef STATISTICS
    if (usage_is_set(_usage,USE_STATISTICS))
      _stat->end_cycle();
#endif    

#ifdef VHDL_TESTBENCH
    // Evaluation before read the ouput signal
//  sc_start(0);
    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
      _interfaces->testbench();
#endif

    log_end(Commit_unit,FUNCTION);
  };

}; // end namespace commit_unit
}; // end namespace ooo_engine
}; // end namespace multi_ooo_engine
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
